"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ux4iot = void 0;
var socket_io_client_1 = require("socket.io-client");
var types_1 = require("./types");
var Ux4iotApi_1 = require("./Ux4iotApi");
var ux4iotState = __importStar(require("./ux4iotState"));
var utils_1 = require("./utils");
var RECONNECT_TIMEOUT = 5000;
var MAX_RECONNECT_TIMEOUT = 30000;
var NETWORK_STATES = {
    UX4IOT_OFFLINE: [
        'ux4iot_unreachable',
        'Failed to fetch sessionId of ux4iot.',
    ],
    SERVER_UNAVAILABLE: [
        'socket_connect_error',
        'Could not establish connection to ux4iot websocket',
    ],
    CLIENT_DISCONNECTED: ['socket_disconnect', 'Client manually disconnected'],
    SERVER_DISCONNECTED: [
        'socket_disconnect',
        'Disconnected / Error Connecting.',
    ],
    CONNECTED: ['socket_connect', 'Connected to ux4iot websocket'],
};
function nextTimeout(timeout, maxTimeout) {
    if (timeout === void 0) { timeout = RECONNECT_TIMEOUT; }
    if (maxTimeout === void 0) { maxTimeout = MAX_RECONNECT_TIMEOUT; }
    return timeout + timeout > maxTimeout ? maxTimeout : timeout + timeout;
}
var Ux4iot = /** @class */ (function () {
    function Ux4iot(options, sessionId, api, onSessionId) {
        var _a, _b;
        this.sessionId = '';
        this.sessionId = sessionId;
        this.api = api;
        this.devMode = (0, types_1.isDevOptions)(options);
        this.retryTimeout = (_a = options.reconnectTimeout) !== null && _a !== void 0 ? _a : RECONNECT_TIMEOUT;
        this.maxRetryTimeout = (_b = options.maxReconnectTimeout) !== null && _b !== void 0 ? _b : MAX_RECONNECT_TIMEOUT;
        this.onSessionId = onSessionId;
        this.onSocketConnectionUpdate = options.onSocketConnectionUpdate;
        this.initializeSocket();
    }
    Ux4iot.create = function (options, onSessionId) {
        return __awaiter(this, void 0, void 0, function () {
            var onSocketConnectionUpdate, reconnectTimeout, maxReconnectTimeout, timeout, maxTimeout, api, sessionId, error_1, _a, reason, description, nextOptions_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        onSocketConnectionUpdate = options.onSocketConnectionUpdate, reconnectTimeout = options.reconnectTimeout, maxReconnectTimeout = options.maxReconnectTimeout;
                        timeout = reconnectTimeout !== null && reconnectTimeout !== void 0 ? reconnectTimeout : RECONNECT_TIMEOUT;
                        maxTimeout = maxReconnectTimeout !== null && maxReconnectTimeout !== void 0 ? maxReconnectTimeout : MAX_RECONNECT_TIMEOUT;
                        api = new Ux4iotApi_1.Ux4iotApi(options);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, api.getSessionId()];
                    case 2:
                        sessionId = _b.sent();
                        api.setSessionId(sessionId);
                        clearTimeout(Ux4iot.initializationTimeout);
                        return [2 /*return*/, new Ux4iot(options, sessionId, api, onSessionId)];
                    case 3:
                        error_1 = _b.sent();
                        _a = NETWORK_STATES.UX4IOT_OFFLINE, reason = _a[0], description = _a[1];
                        onSocketConnectionUpdate === null || onSocketConnectionUpdate === void 0 ? void 0 : onSocketConnectionUpdate(reason, description);
                        console.warn("Trying to initialize again in ".concat(timeout / 1000, " seconds..."));
                        nextOptions_1 = __assign(__assign({}, options), { reconnectTimeout: nextTimeout(timeout, maxTimeout), maxReconnectTimeout: maxTimeout });
                        return [2 /*return*/, new Promise(function (resolve, reject) {
                                Ux4iot.initializationTimeout = setTimeout(function () {
                                    return resolve(Ux4iot.create(nextOptions_1, onSessionId));
                                }, timeout);
                            })];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.destroyInitialization = function () {
        if (Ux4iot.initializationTimeout) {
            console.warn('Initialization interval canceled');
            clearTimeout(Ux4iot.initializationTimeout);
        }
    };
    Ux4iot.prototype.initializeSocket = function () {
        var socketURI = this.api.getSocketURL(this.sessionId);
        this.socket = (0, socket_io_client_1.io)(socketURI, { transports: ['websocket', 'polling'] });
        this.socket.on('connect', this.onConnect.bind(this));
        this.socket.on('connect_error', this.onConnectError.bind(this));
        this.socket.on('disconnect', this.onDisconnect.bind(this));
        this.socket.on('data', this.onData.bind(this));
    };
    Ux4iot.prototype.tryReconnect = function (timeout) {
        var _this = this;
        if (timeout === void 0) { timeout = this.retryTimeout; }
        clearTimeout(this.retryTimeoutAfterError);
        this.log("Trying to reconnect in ".concat(timeout / 1000, " seconds..."));
        this.retryTimeoutAfterError = setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
            var sessionId, error_2, _a, reason, description;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!!this.socket) return [3 /*break*/, 5];
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.api.getSessionId()];
                    case 2:
                        sessionId = _c.sent();
                        this.api.setSessionId(sessionId);
                        this.sessionId = sessionId;
                        return [3 /*break*/, 4];
                    case 3:
                        error_2 = _c.sent();
                        _a = NETWORK_STATES.UX4IOT_OFFLINE, reason = _a[0], description = _a[1];
                        this.log(reason, description, error_2);
                        (_b = this.onSocketConnectionUpdate) === null || _b === void 0 ? void 0 : _b.call(this, reason, description);
                        this.tryReconnect(nextTimeout(timeout !== null && timeout !== void 0 ? timeout : this.retryTimeout, this.maxRetryTimeout));
                        return [2 /*return*/];
                    case 4:
                        this.initializeSocket();
                        _c.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        }); }, timeout);
    };
    Ux4iot.prototype.onConnect = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_c) {
                this.log("Connected to ".concat(this.api.getSocketURL(this.sessionId)));
                this.log('Successfully reconnected. Resubscribing to old state...');
                ux4iotState.resetState();
                console.log('onSessionId called with', this.sessionId);
                (_a = this.onSessionId) === null || _a === void 0 ? void 0 : _a.call(this, this.sessionId); // this callback should be used to reestablish all subscriptions
                (_b = this.onSocketConnectionUpdate) === null || _b === void 0 ? void 0 : _b.call.apply(_b, __spreadArray([this], NETWORK_STATES.CONNECTED, false));
                clearTimeout(this.retryTimeoutAfterError);
                return [2 /*return*/];
            });
        });
    };
    Ux4iot.prototype.onConnectError = function () {
        var _a;
        this.log("on connect error called");
        var socketURL = this.api.getSocketURL(this.sessionId);
        this.log("Failed to establish websocket to ".concat(socketURL));
        var _b = NETWORK_STATES.SERVER_UNAVAILABLE, reason = _b[0], description = _b[1];
        (_a = this.onSocketConnectionUpdate) === null || _a === void 0 ? void 0 : _a.call(this, reason, description);
        this.tryReconnect();
    };
    Ux4iot.prototype.onDisconnect = function (error) {
        var _a, _b;
        this.log("on disconnect called");
        if (error === 'io client disconnect') {
            // https://socket.io/docs/v4/client-api/#event-disconnect
            var _c = NETWORK_STATES.CLIENT_DISCONNECTED, reason = _c[0], description = _c[1];
            this.log(reason, description, error);
            (_a = this.onSocketConnectionUpdate) === null || _a === void 0 ? void 0 : _a.call(this, reason, description);
        }
        else {
            var _d = NETWORK_STATES.SERVER_DISCONNECTED, reason = _d[0], description = _d[1];
            this.log(reason, description, error);
            (_b = this.onSocketConnectionUpdate) === null || _b === void 0 ? void 0 : _b.call(this, reason, description);
            this.socket = undefined;
            this.tryReconnect();
        }
    };
    Ux4iot.prototype.destroy = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                (_a = this.socket) === null || _a === void 0 ? void 0 : _a.disconnect();
                this.socket = undefined;
                clearTimeout(this.retryTimeoutAfterError);
                this.log('socket with id', this.sessionId, 'destroyed');
                return [2 /*return*/];
            });
        });
    };
    Ux4iot.prototype.onData = function (m) {
        return __awaiter(this, void 0, void 0, function () {
            var _i, _a, subscriptions, _b, subscriptions_1, sub, type, deviceId, telemetry, _c, _d, telemetryKey;
            return __generator(this, function (_e) {
                for (_i = 0, _a = Object.values(ux4iotState.state.subscriptions); _i < _a.length; _i++) {
                    subscriptions = _a[_i];
                    for (_b = 0, subscriptions_1 = subscriptions; _b < subscriptions_1.length; _b++) {
                        sub = subscriptions_1[_b];
                        type = sub.type, deviceId = sub.deviceId;
                        if (deviceId === m.deviceId) {
                            switch (type) {
                                case 'telemetry': {
                                    if ((0, utils_1.isTelemetryMessage)(m)) {
                                        telemetry = {};
                                        for (_c = 0, _d = sub.telemetryKeys; _c < _d.length; _c++) {
                                            telemetryKey = _d[_c];
                                            if (m.telemetry[telemetryKey] !== undefined) {
                                                telemetry[telemetryKey] = m.telemetry[telemetryKey];
                                            }
                                        }
                                        sub.onData(m.deviceId, telemetry, m.timestamp);
                                    }
                                    break;
                                }
                                case 'connectionState':
                                    (0, utils_1.isConnectionStateMessage)(m) &&
                                        sub.onData(m.deviceId, m.connectionState, m.timestamp);
                                    break;
                                case 'd2cMessages':
                                    (0, utils_1.isD2CMessage)(m) && sub.onData(m.deviceId, m.message, m.timestamp);
                                    break;
                                case 'deviceTwin':
                                    (0, utils_1.isDeviceTwinMessage)(m) &&
                                        sub.onData(m.deviceId, m.deviceTwin, m.timestamp);
                                    break;
                            }
                        }
                    }
                }
                return [2 /*return*/];
            });
        });
    };
    Ux4iot.prototype.patchDesiredProperties = function (grantRequest, patch, onGrantError) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.grant(grantRequest, onGrantError)];
                    case 1:
                        _a.sent();
                        if (!ux4iotState.hasGrant(grantRequest)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.api.patchDesiredProperties(grantRequest.deviceId, patch)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.invokeDirectMethod = function (grantRequest, options, onGrantError) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.grant(grantRequest, onGrantError)];
                    case 1:
                        _a.sent();
                        if (!ux4iotState.hasGrant(grantRequest)) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.api.invokeDirectMethod(grantRequest.deviceId, options)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.grant = function (grantRequest, onGrantError) {
        return __awaiter(this, void 0, void 0, function () {
            var grantResponse;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (ux4iotState.hasGrant(grantRequest)) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, this.api.requestGrant(grantRequest)];
                    case 1:
                        grantResponse = _a.sent();
                        if (grantResponse === types_1.GRANT_RESPONSES.GRANTED) {
                            ux4iotState.addGrant(grantRequest);
                        }
                        else {
                            onGrantError === null || onGrantError === void 0 ? void 0 : onGrantError(grantResponse);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.subscribe = function (subscriberId, subscriptionRequest, onData, onSubscriptionError, onGrantError) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var grantRequest, response, error_3;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        grantRequest = (0, utils_1.getGrantFromSubscriptionRequest)(subscriptionRequest);
                        return [4 /*yield*/, this.grant(grantRequest, onGrantError)];
                    case 1:
                        _b.sent();
                        if (!ux4iotState.hasGrant(grantRequest)) return [3 /*break*/, 8];
                        return [4 /*yield*/, this.getLastValueForSubscriptionRequest(subscriptionRequest)];
                    case 2:
                        response = _b.sent();
                        onData(response.deviceId, response.data, response.timestamp);
                        _b.label = 3;
                    case 3:
                        _b.trys.push([3, 6, , 7]);
                        if (!(ux4iotState.getNumberOfSubscribers(subscriptionRequest) === 0)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.api.subscribe(subscriptionRequest)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        ux4iotState.addSubscription(subscriberId, subscriptionRequest, onData);
                        return [3 /*break*/, 7];
                    case 6:
                        error_3 = _b.sent();
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError((_a = error_3.response) === null || _a === void 0 ? void 0 : _a.data);
                        return [3 /*break*/, 7];
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError('No grant for subscription');
                        ux4iotState.removeSubscription(subscriberId, subscriptionRequest);
                        _b.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.unsubscribe = function (subscriberId, subscriptionRequest, onSubscriptionError, onGrantError) {
        return __awaiter(this, void 0, void 0, function () {
            var grantRequest, error_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        grantRequest = (0, utils_1.getGrantFromSubscriptionRequest)(subscriptionRequest);
                        return [4 /*yield*/, this.grant(grantRequest, onGrantError)];
                    case 1:
                        _a.sent();
                        if (!ux4iotState.hasGrant(grantRequest)) return [3 /*break*/, 7];
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, 5, , 6]);
                        if (!(ux4iotState.getNumberOfSubscribers(subscriptionRequest) === 1)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.api.unsubscribe(subscriptionRequest)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        ux4iotState.removeSubscription(subscriberId, subscriptionRequest);
                        return [3 /*break*/, 6];
                    case 5:
                        error_4 = _a.sent();
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError(error_4);
                        return [3 /*break*/, 6];
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError('No grant for subscription');
                        _a.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.subscribeAllTelemetry = function (sessionId, deviceId, telemetryKeys, subscriberId, onData, onSubscriptionError, onGrantError) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var subscriptionRequests, grantRequest, response, filteredSubscriptions, _i, subscriptionRequests_1, sr, error_5, _b, subscriptionRequests_2, sr;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        subscriptionRequests = telemetryKeys.map(function (telemetryKey) { return ({
                            sessionId: sessionId,
                            deviceId: deviceId,
                            telemetryKey: telemetryKey,
                            type: 'telemetry',
                        }); });
                        grantRequest = {
                            sessionId: sessionId,
                            deviceId: deviceId,
                            type: 'telemetry',
                            telemetryKey: null,
                        };
                        return [4 /*yield*/, this.grant(grantRequest, onGrantError)];
                    case 1:
                        _c.sent();
                        if (!ux4iotState.hasGrant(grantRequest)) return [3 /*break*/, 8];
                        return [4 /*yield*/, this.getLastTelemetryValues(deviceId, subscriptionRequests)];
                    case 2:
                        response = _c.sent();
                        // response.data = { [telemetryKey]: { value: v, timestamp: t }, ...}
                        onData(response.deviceId, response.data, response.timestamp);
                        _c.label = 3;
                    case 3:
                        _c.trys.push([3, 6, , 7]);
                        filteredSubscriptions = subscriptionRequests.filter(function (s) { return ux4iotState.getNumberOfSubscribers(s) === 0; });
                        if (!(filteredSubscriptions.length > 0)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.api.subscribeAll(filteredSubscriptions)];
                    case 4:
                        _c.sent();
                        _c.label = 5;
                    case 5:
                        // we have to iterate over all subscriptionRequests because the state needs to save all subscribers with subscriberId
                        for (_i = 0, subscriptionRequests_1 = subscriptionRequests; _i < subscriptionRequests_1.length; _i++) {
                            sr = subscriptionRequests_1[_i];
                            ux4iotState.addSubscription(subscriberId, sr, onData);
                        }
                        return [3 /*break*/, 7];
                    case 6:
                        error_5 = _c.sent();
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError((_a = error_5.response) === null || _a === void 0 ? void 0 : _a.data);
                        return [3 /*break*/, 7];
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError('No grant for subscription');
                        for (_b = 0, subscriptionRequests_2 = subscriptionRequests; _b < subscriptionRequests_2.length; _b++) {
                            sr = subscriptionRequests_2[_b];
                            ux4iotState.removeSubscription(subscriberId, sr);
                        }
                        _c.label = 9;
                    case 9: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.unsubscribeAllTelemetry = function (sessionId, deviceId, telemetryKeys, subscriberId, onSubscriptionError, onGrantError) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var subscriptionRequests, grantRequest, filteredSubscriptions, _i, subscriptionRequests_3, sr, error_6;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        subscriptionRequests = telemetryKeys.map(function (telemetryKey) { return ({
                            sessionId: sessionId,
                            deviceId: deviceId,
                            telemetryKey: telemetryKey,
                            type: 'telemetry',
                        }); });
                        grantRequest = {
                            sessionId: sessionId,
                            deviceId: deviceId,
                            type: 'telemetry',
                            telemetryKey: null,
                        };
                        return [4 /*yield*/, this.grant(grantRequest, onGrantError)];
                    case 1:
                        _b.sent();
                        if (!ux4iotState.hasGrant(grantRequest)) return [3 /*break*/, 7];
                        _b.label = 2;
                    case 2:
                        _b.trys.push([2, 5, , 6]);
                        filteredSubscriptions = subscriptionRequests.filter(function (s) { return ux4iotState.getNumberOfSubscribers(s) === 1; });
                        if (!(filteredSubscriptions.length > 0)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.api.unsubscribeAll(filteredSubscriptions)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        // we have to iterate over all subscriptionRequests because the state needs to save all subscribers with subscriberId
                        for (_i = 0, subscriptionRequests_3 = subscriptionRequests; _i < subscriptionRequests_3.length; _i++) {
                            sr = subscriptionRequests_3[_i];
                            ux4iotState.removeSubscription(subscriberId, sr);
                        }
                        return [3 /*break*/, 6];
                    case 5:
                        error_6 = _b.sent();
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError((_a = error_6.response) === null || _a === void 0 ? void 0 : _a.data);
                        return [3 /*break*/, 6];
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        onSubscriptionError === null || onSubscriptionError === void 0 ? void 0 : onSubscriptionError('No grant for subscription');
                        _b.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.hasSubscription = function (subscriberId, subscriptionRequest) {
        return ux4iotState.hasSubscription(subscriberId, subscriptionRequest);
    };
    Ux4iot.prototype.getSubscriberIdSubscriptions = function (subscriberId) {
        var registered = ux4iotState.state.subscriptions[subscriberId];
        var subscriptions = {};
        if (registered) {
            for (var _i = 0, registered_1 = registered; _i < registered_1.length; _i++) {
                var sub = registered_1[_i];
                if (sub.type === 'telemetry') {
                    subscriptions[sub.deviceId] = sub.telemetryKeys;
                }
                else {
                    subscriptions[sub.deviceId] = [];
                }
            }
        }
        return subscriptions;
    };
    Ux4iot.prototype.removeSubscriberId = function (subscriberId, sessionId) {
        return __awaiter(this, void 0, void 0, function () {
            var subscriptions, byDeviceId, _i, _a, _b, deviceId, subscriptions_3, _c, subscriptions_2, sub, error_7;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        subscriptions = ux4iotState.state.subscriptions[subscriberId];
                        if (!subscriptions) return [3 /*break*/, 11];
                        byDeviceId = subscriptions.reduce(function (acc, sub) {
                            (acc[sub.deviceId] = acc[sub.deviceId] || []).push(sub);
                            return acc;
                        }, {});
                        _i = 0, _a = Object.entries(byDeviceId);
                        _d.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 11];
                        _b = _a[_i], deviceId = _b[0], subscriptions_3 = _b[1];
                        _c = 0, subscriptions_2 = subscriptions_3;
                        _d.label = 2;
                    case 2:
                        if (!(_c < subscriptions_2.length)) return [3 /*break*/, 10];
                        sub = subscriptions_2[_c];
                        _d.label = 3;
                    case 3:
                        _d.trys.push([3, 8, , 9]);
                        if (!(sub.type === 'telemetry')) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.unsubscribeAllTelemetry(sessionId, deviceId, sub.telemetryKeys, subscriberId)];
                    case 4:
                        _d.sent();
                        return [3 /*break*/, 7];
                    case 5: return [4 /*yield*/, this.unsubscribe(subscriberId, sub)];
                    case 6:
                        _d.sent();
                        _d.label = 7;
                    case 7: return [3 /*break*/, 9];
                    case 8:
                        error_7 = _d.sent();
                        console.warn('could not unsubscribe subscriberId', subscriberId, error_7);
                        return [3 /*break*/, 9];
                    case 9:
                        _c++;
                        return [3 /*break*/, 2];
                    case 10:
                        _i++;
                        return [3 /*break*/, 1];
                    case 11:
                        ux4iotState.cleanSubId(subscriberId);
                        return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.getLastTelemetryValues = function (deviceId, subscriptionRequest) {
        return __awaiter(this, void 0, void 0, function () {
            var telemetryKeys;
            return __generator(this, function (_a) {
                telemetryKeys = subscriptionRequest.map(function (sr) { return sr.telemetryKey; });
                return [2 /*return*/, this.api.getLastTelemetryValues(deviceId, telemetryKeys)];
            });
        });
    };
    Ux4iot.prototype.getLastValueForSubscriptionRequest = function (subscriptionRequest) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var type, deviceId, _b, telemetryKey, error_8;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        type = subscriptionRequest.type, deviceId = subscriptionRequest.deviceId;
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 11, , 12]);
                        _b = type;
                        switch (_b) {
                            case 'connectionState': return [3 /*break*/, 2];
                            case 'deviceTwin': return [3 /*break*/, 4];
                            case 'telemetry': return [3 /*break*/, 6];
                            case 'd2cMessages': return [3 /*break*/, 8];
                        }
                        return [3 /*break*/, 9];
                    case 2: return [4 /*yield*/, this.api.getLastConnectionState(deviceId)];
                    case 3: return [2 /*return*/, _c.sent()];
                    case 4: return [4 /*yield*/, this.api.getLastDeviceTwin(deviceId)];
                    case 5: return [2 /*return*/, _c.sent()];
                    case 6:
                        telemetryKey = subscriptionRequest.telemetryKey;
                        return [4 /*yield*/, this.api.getLastTelemetryValue(deviceId, telemetryKey)];
                    case 7: return [2 /*return*/, _c.sent()];
                    case 8: return [2 /*return*/, Promise.resolve({ deviceId: deviceId, data: undefined, timestamp: '' })];
                    case 9: return [2 /*return*/, Promise.resolve({ deviceId: deviceId, data: undefined, timestamp: '' })];
                    case 10: return [3 /*break*/, 12];
                    case 11:
                        error_8 = _c.sent();
                        this.log((_a = error_8.response) === null || _a === void 0 ? void 0 : _a.data);
                        return [2 /*return*/, Promise.resolve({ deviceId: deviceId, data: undefined, timestamp: '' })];
                    case 12: return [2 /*return*/];
                }
            });
        });
    };
    Ux4iot.prototype.log = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this.devMode) {
            console.warn.apply(console, __spreadArray(['ux4iot:'], args, false));
        }
    };
    return Ux4iot;
}());
exports.Ux4iot = Ux4iot;
