"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ux4iotApi = void 0;
var axios_1 = __importDefault(require("axios"));
var types_1 = require("./types");
var utils_1 = require("./utils");
var ux4iot_shared_1 = require("./ux4iot-shared");
var Ux4iotApi = /** @class */ (function () {
    function Ux4iotApi(initializationOptions) {
        if ((0, types_1.isDevOptions)(initializationOptions)) {
            (0, utils_1.printDevModeWarning)();
            var _a = (0, ux4iot_shared_1.parseConnectionString)(initializationOptions.adminConnectionString), Endpoint = _a.Endpoint, SharedAccessKey = _a.SharedAccessKey;
            this.axiosInstance = axios_1.default.create({
                baseURL: Endpoint,
                headers: { 'Shared-Access-Key': SharedAccessKey },
            });
            this.ux4iotUrl = Endpoint;
            this.grantRequestFunction = this.defaultGrantRequestFunction;
        }
        else {
            var ux4iotURL = initializationOptions.ux4iotURL, grantRequestFunction = initializationOptions.grantRequestFunction;
            this.axiosInstance = axios_1.default.create({
                baseURL: ux4iotURL,
            });
            this.ux4iotUrl = ux4iotURL;
            this.grantRequestFunction = grantRequestFunction;
        }
    }
    Ux4iotApi.prototype.defaultGrantRequestFunction = function (grant) {
        return __awaiter(this, void 0, void 0, function () {
            var error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.axiosInstance.put('/grants', grant)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        if (axios_1.default.isAxiosError(error_1)) {
                            if (error_1.response) {
                                if (error_1.response.status === 401) {
                                    return [2 /*return*/, types_1.GRANT_RESPONSES.UNAUTHORIZED];
                                }
                                else if (error_1.response.status === 403) {
                                    return [2 /*return*/, types_1.GRANT_RESPONSES.FORBIDDEN];
                                }
                            }
                        }
                        return [2 /*return*/, types_1.GRANT_RESPONSES.ERROR];
                    case 3: return [2 /*return*/, types_1.GRANT_RESPONSES.GRANTED];
                }
            });
        });
    };
    Ux4iotApi.prototype.setSessionId = function (sessionId) {
        this.sessionId = sessionId;
    };
    Ux4iotApi.prototype.getSessionId = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.axiosInstance.post('/session')];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data.sessionId];
                }
            });
        });
    };
    Ux4iotApi.prototype.getSocketURL = function (sessionId) {
        return "".concat(this.ux4iotUrl, "?sessionId=").concat(sessionId);
    };
    Ux4iotApi.prototype.requestGrant = function (grantBase) {
        return __awaiter(this, void 0, void 0, function () {
            var grant;
            return __generator(this, function (_a) {
                if (!this.sessionId)
                    return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                grant = __assign(__assign({}, grantBase), { sessionId: this.sessionId });
                return [2 /*return*/, this.grantRequestFunction(grant)];
            });
        });
    };
    Ux4iotApi.prototype.subscribe = function (subscriptionRequestBase) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.put('/subscription', __assign(__assign({}, subscriptionRequestBase), { sessionId: this.sessionId }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Ux4iotApi.prototype.unsubscribe = function (subscriptionRequestBase) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.delete('/subscription', {
                                data: __assign(__assign({}, subscriptionRequestBase), { sessionId: this.sessionId }),
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Ux4iotApi.prototype.subscribeAll = function (subscriptionRequests) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.put('/subscriptions', subscriptionRequests.map(function (sr) { return (__assign(__assign({}, sr), { sessionId: _this.sessionId })); }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Ux4iotApi.prototype.unsubscribeAll = function (subscriptionRequests) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.delete('/subscriptions', {
                                data: subscriptionRequests.map(function (sr) { return (__assign(__assign({}, sr), { sessionId: _this.sessionId })); }),
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Ux4iotApi.prototype.getLastTelemetryValue = function (deviceId, telemetryKey) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.get("/lastValue/".concat(deviceId, "/").concat(telemetryKey), { headers: { sessionId: this.sessionId } })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    Ux4iotApi.prototype.getLastTelemetryValues = function (deviceId, telemetryKeys) {
        return __awaiter(this, void 0, void 0, function () {
            var response, telemetryValues, _i, _a, _b, key, value;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, this.axiosInstance.get("/lastValue/".concat(deviceId), {
                            headers: { sessionId: this.sessionId },
                        })];
                    case 1:
                        response = _c.sent();
                        telemetryValues = {};
                        for (_i = 0, _a = Object.entries(response.data.data); _i < _a.length; _i++) {
                            _b = _a[_i], key = _b[0], value = _b[1];
                            if (telemetryKeys.includes(key)) {
                                telemetryValues[key] = value;
                            }
                        }
                        return [2 /*return*/, {
                                deviceId: response.data.deviceId,
                                data: telemetryValues,
                                timestamp: response.data.timestamp,
                            }];
                }
            });
        });
    };
    Ux4iotApi.prototype.getLastDeviceTwin = function (deviceId) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.get("/deviceTwin/".concat(deviceId), {
                                headers: { sessionId: this.sessionId },
                            })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    Ux4iotApi.prototype.getLastConnectionState = function (deviceId) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.get("/connectionState/".concat(deviceId), { headers: { sessionId: this.sessionId } })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    Ux4iotApi.prototype.invokeDirectMethod = function (deviceId, options) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.post('/directMethod', { deviceId: deviceId, methodParams: options }, { headers: { sessionId: this.sessionId } })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    Ux4iotApi.prototype.patchDesiredProperties = function (deviceId, desiredPropertyPatch) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.sessionId)
                            return [2 /*return*/, Promise.reject('There is no ux4iot session')];
                        return [4 /*yield*/, this.axiosInstance.patch('/deviceTwinDesiredProperties', { deviceId: deviceId, desiredPropertyPatch: desiredPropertyPatch }, { headers: { sessionId: this.sessionId } })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    return Ux4iotApi;
}());
exports.Ux4iotApi = Ux4iotApi;
