"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useConnectionState = void 0;
var react_1 = require("react");
var useSubscription_1 = require("./useSubscription");
var useConnectionState = function (deviceId, options) {
    if (options === void 0) { options = {}; }
    var onData = options.onData;
    var onDataRef = (0, react_1.useRef)(onData);
    var _a = (0, react_1.useState)(), connectionState = _a[0], setConnectionState = _a[1];
    (0, react_1.useEffect)(function () {
        onDataRef.current = onData;
    }, [onData]);
    var onConnectionState = (0, react_1.useCallback)(function (deviceId, connectionState, timestamp) {
        var _a;
        if (connectionState !== undefined) {
            setConnectionState(connectionState);
            (_a = onDataRef.current) === null || _a === void 0 ? void 0 : _a.call(onDataRef, deviceId, connectionState, timestamp);
        }
    }, [setConnectionState]);
    var subscriptionRequest = (0, react_1.useCallback)(function (sessionId) {
        return { deviceId: deviceId, type: 'connectionState', sessionId: sessionId };
    }, [deviceId]);
    (0, useSubscription_1.useSubscription)(options, onConnectionState, subscriptionRequest);
    return connectionState;
};
exports.useConnectionState = useConnectionState;
