"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useD2CMessages = void 0;
var react_1 = require("react");
var useSubscription_1 = require("./useSubscription");
var useD2CMessages = function (deviceId, options) {
    if (options === void 0) { options = {}; }
    var onData = options.onData;
    var onDataRef = (0, react_1.useRef)(onData);
    var _a = (0, react_1.useState)(), lastMessage = _a[0], setLastMessage = _a[1];
    (0, react_1.useEffect)(function () {
        onDataRef.current = onData;
    }, [onData]);
    var onMessage = (0, react_1.useCallback)(function (deviceId, message, timestamp) {
        var _a;
        if (message) {
            setLastMessage(message);
            (_a = onDataRef.current) === null || _a === void 0 ? void 0 : _a.call(onDataRef, deviceId, message, timestamp);
        }
    }, [setLastMessage]);
    var subscriptionRequest = (0, react_1.useCallback)(function (sessionId) {
        return { deviceId: deviceId, type: 'd2cMessages', sessionId: sessionId };
    }, [deviceId]);
    (0, useSubscription_1.useSubscription)(options, onMessage, subscriptionRequest);
    return lastMessage;
};
exports.useD2CMessages = useD2CMessages;
