"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDeviceTwin = void 0;
var react_1 = require("react");
var useSubscription_1 = require("./useSubscription");
var useDeviceTwin = function (deviceId, options) {
    if (options === void 0) { options = {}; }
    var onData = options.onData;
    var onDataRef = (0, react_1.useRef)(onData);
    var _a = (0, react_1.useState)(), twin = _a[0], setTwin = _a[1];
    (0, react_1.useEffect)(function () {
        onDataRef.current = onData;
    }, [onData]);
    var onDeviceTwin = (0, react_1.useCallback)(function (deviceId, deviceTwin, timestamp) {
        var _a;
        if (deviceTwin) {
            setTwin(deviceTwin);
            (_a = onDataRef.current) === null || _a === void 0 ? void 0 : _a.call(onDataRef, deviceId, deviceTwin, timestamp);
        }
    }, [setTwin]);
    var subscriptionRequest = (0, react_1.useCallback)(function (sessionId) {
        return { deviceId: deviceId, type: 'deviceTwin', sessionId: sessionId };
    }, [deviceId]);
    (0, useSubscription_1.useSubscription)(options, onDeviceTwin, subscriptionRequest);
    return twin;
};
exports.useDeviceTwin = useDeviceTwin;
