import { TelemetryState } from './telemetryState';
import { Subscribers, TelemetryCallback, GrantErrorCallback, SubscriptionErrorCallback } from './base/types';
export type { TelemetryValue, TelemetryState } from './telemetryState';
declare type UseMultiTelemetryOutput = {
    addTelemetry: (deviceId: string, telemetryKeys: string[]) => Promise<void>;
    removeTelemetry: (deviceId: string, telemetryKeys: string[]) => Promise<void>;
    toggleTelemetry: (deviceId: string, telemetryKey: string) => Promise<void>;
    isSubscribed: (deviceId: string, telemetryKey: string) => boolean;
    telemetry: TelemetryState;
    currentSubscribers: Subscribers;
};
declare type HookOptions = {
    initialSubscribers?: Subscribers;
    onData?: TelemetryCallback;
    onGrantError?: GrantErrorCallback;
    onSubscriptionError?: SubscriptionErrorCallback;
};
export declare const useMultiTelemetry: (options: HookOptions) => UseMultiTelemetryOutput;
